#include <iMesh.h>
#include <stdio.h>
#include <string.h>
#include <error.h>

extern struct iBase_Error iMesh_LAST_ERROR;
#define MCHK(err) if (err) { ReportErrorITAPS(err,__FILE__,__LINE__,__func__,"iMesh",&iMesh_LAST_ERROR); return err; }
static void ReportErrorITAPS(int err,const char *file,int line,const char *func,const char *iface,const struct iBase_Error *estruct)
{
  error(1,0,"%s:%d in %s() %s error %d(%d) description:\n%s\n",file,line,func,iface,
        err,estruct->error_type,estruct->description);
}

int main(int argc,char *argv[])
{
  iMesh_Instance mesh;
  int err;

  if (argc != 2) error(1,0,"usage: %s FILE\n",argv[0]);

  iMesh_newMesh(0,&mesh,&err,0);MCHK(err);
  iMesh_load(mesh,0,argv[1],0,&err,strlen(argv[1]),0);MCHK(err);
  iMesh_dtor(mesh,&err);MCHK(err);
  fprintf(stderr,"iMesh_dtor() returned okay\n");
  return 0;
}
